SystemOrganization addCategory: #'MC2-Interface-Announcements'!
SystemOrganization addCategory: #'MC2-Interface-Environment'!
SystemOrganization addCategory: #'MC2-Interface-Model'!
SystemOrganization addCategory: #'MC2-Interface-Notifications'!

GRNotification subclass: #MDNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Notifications'!

MDNotification subclass: #MDCommentRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Notifications'!

!MDCommentRequest methodsFor: 'defaults' stamp: 'cwp 12/27/2007 21:36'!
defaultAction
	^ self resume: nil! !

MDNotification subclass: #MDMergeRequest
	instanceVariableNames: 'merges workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Notifications'!

!MDMergeRequest class methodsFor: 'signalling' stamp: 'jf 9/8/2009 16:32'!
includeAll: versions in: aWorkspace
	| merges |
	merges := versions
				collect: [:ea | MDMerge toInclude: ea in: aWorkspace]
				thenSelect: [:ea | ea isNoOp not].
	^ self new
		merges: merges;
		workspace: aWorkspace;
		signal! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 8/9/2010 10:54'!
defaultAction
	MDConflictBrowser handleRequest: self! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges
	^ merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'dc 6/14/2007 10:17'!
merges: aCollection
	merges := aCollection! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace
	^ workspace! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace: aWorkspace 
	workspace := aWorkspace! !

MDNotification subclass: #MDTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Notifications'!

!MDTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:47'!
prompt: pString template: tString
	^ (self basicNew initializeWithPrompt: pString template: tString) signal! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
defaultAction
	^ MDPlatform current 
		prompt: self prompt 
		template: self template! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:47'!
initializeWithPrompt: pString template: tString
	self initialize.
	prompt := pString.
	template := tString.! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
prompt
	^ prompt! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
template
	^ template! !

MDAnnouncement subclass: #MDEnvironmentChangeAnnouncement
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

!MDEnvironmentChangeAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:15'!
new
	self shouldNotImplement! !

!MDEnvironmentChangeAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:13'!
environment
	^ environment! !

!MDEnvironmentChangeAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:40'!
environment: anEnvironment
	environment := anEnvironment! !

!MDEnvironmentChangeAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:11'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

MDEnvironmentChangeAnnouncement subclass: #MDEnvironmentRepositoryAnnouncement
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

!MDEnvironmentRepositoryAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:20'!
environment: anEnvironment repository: aRepository
	^ self basicNew
		initializeWithEnvironment: anEnvironment repository: aRepository;
		yourself! !

!MDEnvironmentRepositoryAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:19'!
initializeWithEnvironment: anEnvironment repository: aRepository
	self initializeWithEnvironment: anEnvironment.
	repository := aRepository! !

!MDEnvironmentRepositoryAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:18'!
repository
	^ repository! !

MDEnvironmentRepositoryAnnouncement subclass: #MDRepositoryAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDEnvironmentRepositoryAnnouncement subclass: #MDRepositoryRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDEnvironmentChangeAnnouncement subclass: #MDEnvironmentSliceAnnouncement
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

!MDEnvironmentSliceAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:14'!
environment: anEnvironment slice: aSlice
	^ self basicNew
		initializeWithEnvironment: anEnvironment slice: aSlice;
		yourself! !

!MDEnvironmentSliceAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:13'!
initializeWithEnvironment: anEnvironment slice: aSlice
	self initializeWithEnvironment: anEnvironment.
	slice := aSlice! !

!MDEnvironmentSliceAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:05'!
slice
	^ slice! !

MDEnvironmentSliceAnnouncement subclass: #MDSliceAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDEnvironmentSliceAnnouncement subclass: #MDSliceRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDEnvironmentSliceAnnouncement subclass: #MDSliceTouched
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDSliceTouched subclass: #MDSliceClean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

MDSliceTouched subclass: #MDSliceDirty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Announcements'!

!MDSliceTouched class methodsFor: 'as yet unclassified' stamp: 'jf 11/25/2009 15:41'!
slice: aSlice
	"Historians need to signal these and do not have access to their Environment"
	^ self environment: nil slice: aSlice! !

!MDWorkspace methodsFor: '*mc2-interface' stamp: 'cwp 7/20/2010 10:58'!
changeForElement: anElement do: aBlock
	| version variant |
	version := versions at: anElement ifAbsent: [ MDNullVersion forElement: anElement ].
	^ (facade isUpToDate: version variant) ifFalse: 
		[variant := facade updateVariant: version variant copy.
		aBlock value: (MDChange version: version variant: variant)]! !

!MDWorkspace methodsFor: '*mc2-interface' stamp: 'cwp 7/20/2010 10:57'!
changeFromVersion: aVersion do: aBlock
	| variant |
	(facade isUpToDate: aVersion variant) ifFalse: 
		[variant := facade updateVariant: aVersion variant copy.
		aBlock value: (MDChange version: aVersion variant: variant)]! !

MDObject subclass: #MDChange
	instanceVariableNames: 'version variant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Model'!

!MDChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:28'!
new
	self shouldNotImplement! !

!MDChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:28'!
version: aVersion variant: aVariant
	^ self basicNew
		initializeWithVersion: aVersion variant: aVariant;
		yourself! !

!MDChange methodsFor: 'comparing' stamp: 'cwp 5/24/2008 21:45'!
<= other
	^ self element printString <= other element printString! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 21:43'!
element
	^ variant element! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 22:18'!
final
	^ variant! !

!MDChange methodsFor: 'testing' stamp: 'cwp 5/24/2008 16:14'!
hasEffect
	^ version variant ~= variant! !

!MDChange methodsFor: 'initialization' stamp: 'jf 11/8/2009 18:27'!
initializeWithVersion: aVersion variant: aVariant
	self initialize.
	version := aVersion.
	variant := aVariant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 7/26/2008 16:10'!
name
	^ variant properties name ifNil: [self element printString]! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 22:18'!
original
	^ version variant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 15:52'!
variant
	^ variant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 15:52'!
version
	^ version
	! !

MDObject subclass: #MDEnvironment
	instanceVariableNames: 'announcer store historians repositories bench'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'MC2-Interface-Environment'!

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
createDefault
	^ self new! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
default
	^ Default ifNil: [Default := self createDefault]! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 10:40'!
forTesting
	^ self new
		! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2009 16:35'!
reset
	Default ifNotNil:
		[Default unsubscribe.
		Default := nil]! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 11/25/2009 14:29'!
addRepository: aRepository
	repositories register: aRepository.
	self announce: (MDRepositoryAdded environment: self repository: aRepository).
	^ aRepository! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 11/25/2009 16:47'!
addSlice: aSlice
	| historian |
	historian := MDHistorian forSlice: aSlice.
	historians register: historian.
	self forwardAnnouncementsFrom: historian.
	self announce: (MDSliceAdded environment: self slice: aSlice).
	^ aSlice! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/16/2009 15:14'!
allElementsForSlice: aSlice do: aBlock 
	| elements parents snapshot elem memo |
	elements := aSlice elements.
	elements do: aBlock.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ self ]) parents.
	parents isEmpty ifTrue: [ ^ self ].
	memo := (self store get: parents first) ifNil: [ ^ self ].
	snapshot := (self store get: memo reference) ifNil: [ ^ self ].
	(snapshot getVersionsFrom: self store) do: 
		[ :version | 
		elem := version element.
		(elements includes: elem) ifFalse: [ aBlock value: elem ] ]! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 18:26'!
annElementChanged: announcement
	self noteElementChanged: announcement element! !

!MDEnvironment methodsFor: 'announcing' stamp: 'jf 11/19/2009 16:10'!
announce: anObject
	self announcer announce: anObject! !

!MDEnvironment methodsFor: 'announcing' stamp: 'cwp 11/25/2009 14:47'!
announcer
	^ announcer! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 7/20/2010 10:32'!
changesForSlice: aSlice 
	| result parents memo snapshot |
	result := Set new.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: 
			[ ^ #() ]) parents.
	parents isEmpty ifTrue: [ ^ result ].
	memo := (self store get: parents first) ifNil: [ ^ result ].
	snapshot := (self store get: memo reference) ifNil: [ ^ result ].
	(aSlice expandVersions: (snapshot getVersionsFrom: self store)) do: 
		[ :version | 
		(self workspaceForSlice: aSlice)
			changeFromVersion: version
			do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/14/2009 09:46'!
environment
	^ self! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 11/25/2009 14:56'!
forwardAnnouncement: anAnnouncement
	self announce: anAnnouncement! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 11/25/2009 15:08'!
forwardAnnouncementsFrom: anObject 
	anObject announcer 
		observe: MDAnnouncement
		send: #forwardAnnouncement:
		to: self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp 
	^ historians objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp ifAbsent: aBlock 
	^ historians 
		objectWithId: aHashstamp
		ifAbsent: aBlock! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 18:18'!
historians
	^ historians ! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/9/2010 11:16'!
include: aMemo
	| slice snapshot ws versions |
	slice := self sliceWithId: aMemo sliceId.
	MDPlatform current withCursor: #read do: 
		[ws := bench workspaceForSlice: slice.
		snapshot := store get: aMemo reference.
		versions := snapshot getVersionsFrom: store for: ws].
	MDMergeRequest includeAll: (slice expandVersions: versions) in: ws.
	(self historianWithId: aMemo sliceId) noteInclude: aMemo! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:13'!
includesRepositoryId: aHashstamp 
	^ self repositories anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:15'!
includesSliceId: aHashstamp 
	^ self slices anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'initialize-release' stamp: 'cwp 8/9/2010 10:08'!
initialize
	super initialize.
	announcer := MDAnnouncer new.
	bench := MDBench new.
	store := MDMemoryRepository named: 'store'.
	historians := MDRegistry new.
	repositories := MDRegistry new.
! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
isDirty: aSlice 
	^ (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ false ]) isDirty! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/9/2010 11:23'!
load: aMemo
	| slice sliceId snapshot |
	sliceId := aMemo sliceId.
	slice := (self sliceWithId: sliceId) ifNil: [ MDExplicitSlice named: 'temporary' ].
	MDPlatform current withCursor: #read do: 
		[snapshot := store get: aMemo reference.
		bench load: snapshot withSlice: slice from: store].
	(self historianWithId: aMemo sliceId ifAbsent: [ ^ self ]) noteLoad: aMemo! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteClean: aSlice 
	^ (self historianWithId: aSlice id) markClean! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteDirty: aSlice 
	^ (self historianWithId: aSlice id) markDirty! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 22:03'!
noteElementChanged: anElement 
	historians objects do: [ :ea | ea noteElementChanged: anElement ]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 7/19/2010 16:53'!
removeRepositoryId: aHashstamp 
	| repository |
	repository := repositories unregisterId: aHashstamp ifAbsent: [^ nil].
	self announce: (MDRepositoryRemoved environment: self repository: repository).
	^ repository! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 7/19/2010 16:53'!
removeSliceId: aHashstamp 
	| slice |
	slice := (historians unregisterId: aHashstamp ifAbsent: [^ nil]) slice.
	self announce: (MDSliceRemoved environment: self slice: slice).
	^ slice! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 9/5/2009 22:00'!
repositories
	^ repositories objects! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 17:43'!
repositoryWithId: aHashstamp
	^ repositories objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/9/2010 10:29'!
save: aSlice
	| memo historian snapshot |
	historian := self historianWithId: aSlice id.
	memo := historian memo.
	^ memo ifNotNil: 
		[MDPlatform current withCursor: #write do: 
			[snapshot := bench save: aSlice to: store.
			memo setSnapshot: snapshot slice: aSlice.
			store put: memo].
		historian noteSave: memo.
		memo ]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'jf 9/6/2009 13:34'!
sliceWithId: sliceId 
	| historian |
	historian := self historianWithId: sliceId.
	^ historian ifNotNil: [historian slice]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 17:57'!
slices
	^ historians objects collect: [:ea | ea slice]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/12/2009 10:24'!
store
	^ store! !

!MDEnvironment methodsFor: 'notifications' stamp: 'jf 11/19/2009 16:09'!
subscribe
	self announcer 
		observe: MDElementChange
		send: #annElementChanged:
		to: self! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 7/20/2010 10:34'!
unsavedChangesForSlice: aSlice 
	| result ws |
	result := Set new.
	ws := self workspaceForSlice: aSlice.
	self 
		allElementsForSlice: aSlice
		do: 
			[ :element | 
			ws 
				changeForElement: element
				do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'notifications' stamp: 'jf 11/19/2009 16:09'!
unsubscribe
	self announcer unsubscribe: self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/9/2010 10:08'!
workspaceForSlice: aSlice
	^ bench workspaceForSlice: aSlice! !

MDObject subclass: #MDHistorian
	instanceVariableNames: 'slice ancestry properties ordinal isDirty announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Environment'!

!MDHistorian class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 16:59'!
forSlice: aSlice
	^ self basicNew
		initializeWithSlice: aSlice;
		yourself! !

!MDHistorian class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 17:00'!
new
	self shouldNotImplement! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 1/22/2010 20:24'!
ancestry
	^ ancestry! !

!MDHistorian methodsFor: 'announcing' stamp: 'jf 11/19/2009 16:15'!
announce: anObject
	self announcer announce: anObject! !

!MDHistorian methodsFor: 'announcing' stamp: 'cwp 11/25/2009 15:06'!
announcer
	^ announcer! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 1/22/2010 20:25'!
basicMemo
	| memo |
	memo := MDMemo ancestry: ancestry.
	self update: memo properties.
	MDPlatform current updateMemoProperties: memo properties.
	memo properties ordinal: (self ordinal).
	^ memo! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 1/22/2010 21:05'!
clearAncestry

	ancestry := MDAncestry empty.
	! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:19'!
id
	^ slice id! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
incrementOrdinal
	ordinal := ordinal + 1! !

!MDHistorian methodsFor: 'initialize-release' stamp: 'cwp 1/22/2010 20:57'!
initializeWithSlice: aSlice
	self initialize.
	slice := aSlice.
	ancestry := MDAncestry empty.
	properties := MDPropertyDictionary new.
	ordinal := 1.
	isDirty := false.
	announcer := MDAnnouncer new.
	! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 3/8/2008 21:27'!
isDirty
	^ isDirty! !

!MDHistorian methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:41'!
markClean
	isDirty ifTrue: 
		[isDirty := false.
		self announce: (MDSliceClean slice: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:41'!
markDirty
	isDirty ifFalse: 
		[isDirty := true.
		self announce: (MDSliceDirty slice: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
memo
	| memo name |
	memo := self basicMemo.
	name := memo nameForSlice: slice.
	^ (MDCommentRequest signal: 'Comment for ', name) ifNotNilDo:
		[:comment | 
		comment isEmpty ifFalse: [memo properties comment: comment].
		self incrementOrdinal.
		memo].
	! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 7/26/2008 17:49'!
noteElementChanged: anElement 
	(slice includes: anElement) ifTrue: [ self markDirty ]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 1/22/2010 20:57'!
noteInclude: aMemo
	
	ancestry addParent: aMemo hashstamp.
	self noteOrdinal: aMemo properties ordinal ! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 1/22/2010 20:57'!
noteLoad: aMemo
	
	ancestry := aMemo childAncestry.
	self noteOrdinal: aMemo properties ordinal.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
noteOrdinal: anInteger 
	
	anInteger ifNotNil: [ordinal := ordinal max: anInteger + 1]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 1/22/2010 20:57'!
noteSave: aMemo
	
	ancestry := aMemo childAncestry.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 3/8/2008 12:35'!
ordinal
	^ ordinal! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 1/22/2010 23:22'!
parents
	^ ancestry parents! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 12/27/2007 21:47'!
properties
	^ properties! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 08:46'!
slice
	^ slice! !

!MDHistorian methodsFor: 'updating' stamp: 'cwp 12/27/2007 21:27'!
update: props
	properties keysAndValuesDo: [:k :v | props at: k put: v]! !

MDObject subclass: #MDMerge
	instanceVariableNames: 'local remote resolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Interface-Model'!

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:32'!
local: localVersion remote: remoteVersion
	^ self basicNew
		initializeWithLocal: localVersion remote: remoteVersion;
		yourself! !

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:58'!
new
	self shouldNotImplement! !

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:32'!
toInclude: aVersion in: aWorkspace 
	| local |
	local := aWorkspace versionForElement: aVersion element.
	^ self local: local remote: aVersion
! !

!MDMerge methodsFor: 'operations' stamp: 'jf 9/8/2009 16:33'!
applyTo: aWorkspace
	aWorkspace includeVersion: resolution onConflict: [:l :r | r variant]! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseLocal
	resolution := local! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseRemote
	resolution := remote! !

!MDMerge methodsFor: 'printing' stamp: 'cwp 10/25/2008 14:39'!
displayOn: aStream
	self remote element printOn: aStream! !

!MDMerge methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:30'!
initializeWithLocal: localVersion remote: remoteVersion
	self initialize.
	local := localVersion.
	remote := remoteVersion.
	resolution := local successor: remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:21'!
isConflict
	^ remote conflictsWith: local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:16'!
isLocal
	^ resolution == local! !

!MDMerge methodsFor: 'testing' stamp: 'avi 3/21/2006 00:14'!
isNoOp
	^ local = remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:19'!
isRemote
	^ resolution == remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 6/9/2005 09:01'!
isResolved
	^ resolution notNil! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
local
	^ local! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
remote
	^ remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
resolution
	^ resolution! !
